Option Strict On
Imports System.ComponentModel
Module Garbage

    ' Creates the RAM consumer
    Sub DoIt(ByRef pfcRam As PerformanceCounter)
        Dim intCounter As Integer
        Console.WriteLine("pre-instance RAM : " & pfcRam.NextValue.ToString())
        Dim objWasteOfSpace As MemoryKiller = New MemoryKiller
        For intCounter = 0 To 10000000
            objWasteOfSpace.Buzzsaw = intCounter
        Next
        Console.WriteLine("post-instance RAM : " & pfcRam.NextValue.ToString())
    End Sub

    ' Main method accepts either "ON" or "OFF"
    Sub main(ByVal strArgument As String)
        Dim pfcRAM As PerformanceCounter
        pfcRAM = New PerformanceCounter("Memory", "Available MBytes")

        If strArgument = "ON" Then
            Call DoIt(pfcRAM)
            Console.WriteLine("Subroutine Exit RAM : " & pfcRAM.NextValue.ToString())
        ElseIf strArgument = "OFF" Then
            Call DoIt(pfcRAM)
            GC.Collect(GC.GetGeneration(pfcRAM))
            Console.WriteLine("Subroutine Exit RAM : " & pfcRAM.NextValue.ToString())
        Else
            Console.WriteLine("Input either ON or OFF or else... no not or else")
        End If
        Console.Read()
    End Sub

    ' Required polymorphed version of Main for design-time testing
    Sub main()
        Call main("ON")
    End Sub
End Module

' (insert comment about class MemoryKiller here that isn't explained just by looking
' at the code)
Class MemoryKiller
    Dim intWipeout(10000000) As Integer

    WriteOnly Property Buzzsaw() As Integer
        Set(ByVal Value As Integer)
            intWipeout(Value) = Value + 1
        End Set
    End Property

End Class